#include "minigui.ch"

#define USR_COMP_PROC_FLAG	63

*------------------------------------------------------------------------------*
Init Procedure _InitPrintGrid
*------------------------------------------------------------------------------*

	InstallMethodHandler ( 'Print' , 'MyGridPrint' )

Return

*------------------------------------------------------------------------------*
Procedure MyGridPrint (  cWindowName , cControlName , MethodName , headers ,types )
*------------------------------------------------------------------------------*
Local i

	If GetControlType ( cControlName , cWindowName ) == 'GRID'

		gridprint( cControlName , cWindowName , headers ,types )

		_HMG_SYSDATA [USR_COMP_PROC_FLAG] := .T.

	else

		_HMG_SYSDATA [USR_COMP_PROC_FLAG] := .F.

	endif

Return


DECLARE window printgrid

function gridprint(grid,window,headers,types,fontsize,orientation,aHeaders,fontname1,showwindow1)
private fontname := ""
PRIVATE fontsizesstr := {}
PRIVATE maxcol1 := 0
PRIVATE headerarr := headers
PRIVATE sizes := {}
PRIVATE selectedprinter := ""
PRIVATE columnarr := {}
PRIVATE fontnumber := 0
PRIVATE i := 0
PRIVATE windowname := window
private lines := 0
private linedata := {}
PRIVATE gridname := grid
PRIVATE typearr := types
PRIVATE psuccess := .f.
PRIVATE aprinternames := aprinters()
PRIVATE defaultprinter := GetDefaultPrinter()
private papernames := {"Letter","Legal","Executive","A3","A4","Custom"}
private papersizes := {{216,279},{216,355.6},{184.1,266.7},{297,420},{210,297},{216,279}}
PRIVATE printerno := 0
PRIVATE header1 := ""
PRIVATE header2 := ""
PRIVATE header3 := ""
DEFAULT fontsize := 12
DEFAULT orientation := "P"
default fontname1 := "Arial"
default aheaders := {"","",""}
DEFAULT ShowWindow1 := .t.
header1 := aheaders[1]
header2 := aheaders[2]
header3 := aheaders[3]
fontname := fontname1
lines := getproperty(windowname,gridname,"itemcount")
IF lines == 0
   msginfo("Nothing to print")
   RETURN nil
ENDIF
IF Len(aprinternames) == 0
   msgstop("No printers installed!","Print Wizard")
   RETURN nil
ENDIF
fontsizesstr := {"8","9","10","11","12","14","16","18","20","22","24","26","28","36","48","72"}
FOR i := 1 TO Len(fontsizesstr)
   IF Val(fontsizesstr[i]) == fontsize
      fontnumber := i
   ENDIF
NEXT i
IF fontnumber == 0
   fontnumber := 1
ENDIF
linedata := getproperty(windowname,gridname,"item",1)
asize(sizes,0)
for i := 1 to len(linedata)
   aadd(sizes,0)
next i
for i := 1 to lines
   linedata := getproperty(windowname,gridname,"item",i)
   for j := 1 to len(linedata)
      sizes[j] := max(sizes[j],printlen(alltrim(linedata[j]),val(alltrim(fontsizesstr[fontnumber])),fontname))
   next j
next i

FOR i := 1 TO Len(headers)
   AAdd(columnarr,{1,headers[i],sizes[i],IIf(typearr[i] == "N",1,0)})
NEXT i
FOR i := 1 TO Len(aprinternames)
   IF Upper(AllTrim(aprinternames[i])) == Upper(AllTrim(defaultprinter))
      printerno := i
      EXIT
   ENDIF
NEXT i
IF printerno == 0
   printerno := 1
ENDIF
IF iswindowdefined(printgrid)
   printgrid.header1.value := header1
   printgrid.header2.value := header2
   printgrid.header3.value := Header3
   printgrid.currentcol.value := 2
   printgrid.maximumcol.value := maxcol1
   printgrid.paperorientation.value := IIf(orientation == "P",2,1)
   printgrid.selectfontsize.value := fontnumber
Else
   define window printgrid at 0,0 width 700 height 440 title "Report Writer" modal nosize nosysmenu
      define tab tab1 at 10,10 width 285 height 335
         define page "Columns"
            define grid columns
               row 30
               col 10
               width 250
               height 240
               widths {0,130,70}
               justify {0,0,1}
               headers {"","Name of the Column","Width (mm)"}
               image {'wrong','right'}
               tooltip "Double Click a Column to toggle between selecting and not selecting for printing."
               ondblclick printgridtoggle()
            end grid
            DEFINE button editdetails
               Row 30
               Col 265
               width 16
               height 16
               tooltip "Edit Text Column Size"
               picture "edit"
               tabstop .f.
               action editcoldetails()
            END button
            define label currentcollabel
               row 275
               col 50
               width 100
               value "Total Width :"
               fontbold .t.
            end label
            define textbox currentcol
               row 275
               col 160
               width 70
               tabstop .f.
               readonly .t.
               value 0.0
               inputmask "999.99"
               numeric .t.
               rightalign .t.
            end textbox
            define label curcolmm
               row 275
               col 230
               value "mm"
               width 25
            end label
            define label maxcollabel
               row 305
               col 50
               width 40
               value "out of"
               fontbold .t.
            end label
            define textbox maximumcol
               row 305
               col 160
               width 70
               tabstop .f.
               value 0.0
               inputmask "999.99"
               readonly .t.
               value maxcol1
               numeric .t.
               rightalign .t.
            end textbox
            define label maxcolmm
               row 305
               col 230
               value "mm"
               width 25
            end label
         end page
         define page "Report Properties"
            DEFINE label header1label
               Row 30
               Col 10
               width 100
               value "Header 1"
            END label
            DEFINE textbox header1
               Row 30
               Col 110
               width 165
               Value header1
               on lostfocus printgridpreview()
            END textbox
            DEFINE label header2label
               Row 70
               Col 10
               width 100
               value "Header 2"
            END label
            DEFINE textbox header2
               Row 70
               Col 110
               Value header2
               on lostfocus printgridpreview()
               width 165
            END textbox
            DEFINE label header3label
               Row 100
               Col 10
               width 100
               value "Header 3"
            END label
            DEFINE textbox Header3
               Row 100
               Col 110
               Value header3
               on lostfocus printgridpreview()
               width 165
            END textbox
            DEFINE label footer1label
               Row 130
               Col 10
               width 100
               value "Footer"
            END label
            DEFINE textbox Footer1
               Row 130
               Col 110
               width 165
               on lostfocus printgridpreview()
            END textbox
            define label selectfontsizelabel
               row 160
               col 10
               value "Font Size"
               width 100
            end label
            define combobox selectfontsize
               row 160
               col 110
               width 50
               items fontsizesstr
               on change fontsizechanged()
               value fontnumber
            end combobox
            define label multilinelabel
               row 190
               col 10
               value "Lengthy Line"
               width 100
            end label
            define combobox wordwrap
               row 190
               col 110
               width 90
               items {"Word Wrap","Truncate"}
               on lostfocus printgridpreview()
               value 2
            end combobox
            define label pagination
               row 220
               col 10
               value "Pagination"
               width 100
            end label
            define combobox pageno
               row 220
               col 110
               width 90
               items {"Off","Top","Bottom"}
               on lostfocus printgridpreview()
               value 2
            end combobox
            define label separatorlab
               row 250
               col 10
               width 100
               value "Grid Lines"
            end label
            DEFINE checkbox collines
               Row 250
               Col 110
               width 60
               on lostfocus printgridpreview()
               caption "Column"
               value .t.
            END checkbox
            DEFINE checkbox rowlines
               Row 250
               Col 180
               width 60
               on lostfocus printgridpreview()
               caption "Row"
               value .t.
            END checkbox
            define label centerlab
               row 280
               col 10
               width 100
               value "Page Center"
            end label
            DEFINE checkbox vertical
               Row 280
               Col 110
               width 60
               on lostfocus printgridpreview()
               caption "Vertical"
               value .t.
            END checkbox
         end page
         define page "Page/Printer"
            define label orientationlabel
               row 30
               col 10
               Value "Orientation"
               width 100
            end label
            define combobox paperorientation
               row 30
               col 110
               width 90
               items {"Landscape","Portrait"}
               on change papersizechanged()
               value IIf(orientation == "P",2,1)
            end combobox
            DEFINE label printerslabel
               Row 60
               Col 10
               width 100
               value "Printer: "
            END label
            DEFINE combobox printers
               Row 60
               Col 110
               width 165
               items aprinternames
               value printerno
            END combobox
            define label sizelabel
               row 90
               col 10
               width 100
               value "Page Size"
            end label
            DEFINE combobox pagesizes
               Row 90
               Col 110
               width 165
               items papernames
               onchange papersizechanged()
            END combobox
            define label widthlabel
               row 120
               col 10
               value "Page Width"
               width 100
            end label
            define textbox width
               row 120
               col 110
               width 60
               inputmask "999.99"
               on lostfocus printgridpreview()
               numeric .t.
               rightalign .t.
            end textbox
            define label widthmm
               row 120
               col 170
               value "mm"
               width 25
            end label
            define label heightlabel
               row 150
               col 10
               value "Page Height"
               width 100
            end label
            define textbox height
               row 150
               col 110
               width 60
               inputmask "999.99"
               on lostfocus printgridpreview()
               numeric .t.
               rightalign .t.
            end textbox
            define label heightmm
               row 150
               col 170
               value "mm"
               width 25
            end label
            define frame margins
               row 180
               col 5
               width 185
               height 80
               caption "Margins (mm)"
            end frame
            define label toplabel
               row 200
               col 10
               width 35
               value "Top"
            end label
            define textbox top
               row 200
               col 45
               width 50
               inputmask "99.99"
               numeric .t.
               on lostfocus printgridpreview()
               rightalign .t.
            end textbox
            define label rightlabel
               row 200
               col 100
               width 35
               value "Right"
            end label
            define textbox right
               row 200
               col 135
               width 50
               inputmask "99.99"
               on lostfocus papersizechanged()
               numeric .t.
               rightalign .t.
            end textbox
            define label leftlabel
               row 230
               col 10
               width 35
               value "Left"
            end label
            define textbox left
               row 230
               col 45
               width 50
               inputmask "99.99"
               on lostfocus papersizechanged()
               numeric .t.
               rightalign .t.
            end textbox
            define label bottomlabel
               row 230
               col 100
               width 35
               value "Bottom"
            end label
            define textbox bottom
               row 230
               col 135
               width 50
               inputmask "99.99"
               numeric .t.
               on lostfocus printgridpreview()
               rightalign .t.
            end textbox
         end page
      end tab
      define button browseprint1
         row 350
         col 160
         caption "Print"
         action printstart()
         width 80
      end button
      define button browseprintcancel
         row 350
         col 260
         caption "Cancel"
         action printgrid.release
         width 80
      end button
      DEFINE statusbar
         statusitem "Welcome to Print Wizard"
      END statusbar
   end window
ENDIF
printgrid.pagesizes.value := 1
printgrid.top.value := 20.0
printgrid.right.value := 20.0
printgrid.bottom.value := 20.0
printgrid.left.value := 20.0

papersizechanged()
printgrid.center
IF .not. showwindow1
   IF printgrid.browseprint1.enabled
      printstart()
   ELSE
      printgrid.activate
   ENDIF
ELSE
   printgrid.activate
ENDIF
return nil

function printcoltally
LOCAL col := 0
for i := 1 to Len(columnarr)
   IF columnarr[i,1] == 1
      col := col + columnarr[i,3] + 2 // 2 mm for column separation
   endif
next i
printgrid.currentcol.value := col
IF printgrid.maximumcol.value >= printgrid.currentcol.value
   printgrid.browseprint1.enabled := .t.
   printgrid.statusbar.item(1) := "Welcome to Print Wizard"
ELSE
   printgrid.statusbar.item(1) := "You had selected more columns than to fit in a the page!"
   printgrid.browseprint1.enabled := .f.
   return nil
endif
return nil

function fontsizechanged
LOCAL fontsize1 := val(alltrim(printgrid.selectfontsize.item(printgrid.selectfontsize.value)))
IF fontsize1 > 0
   linedata := getproperty(windowname,gridname,"item",1)
   asize(sizes,0)
   for i := 1 to len(linedata)
      aadd(sizes,0)
   next i
   for i := 1 to lines
      linedata := getproperty(windowname,gridname,"item",i)
      for j := 1 to len(linedata)
         sizes[j] := max(sizes[j],printlen(alltrim(linedata[j]),fontsize1,fontname))
      next j
   next i
   FOR i := 1 TO Len(columnarr)
      columnarr[i,3] := sizes[i]
   NEXT i
ENDIF
refreshcolumnprintgrid()
printcoltally()
printgridpreview()
return nil



function printstart
LOCAL curline := {}
LOCAL row := 0
LOCAL col := 0
LOCAL lh := 0 // line height
LOCAL pageno := 0
LOCAL printdata := {}
LOCAL justifyarr := {}
LOCAL maxrow1 := 0
LOCAL maxcol1 := printgrid.currentcol.value
LOCAL maxlines := 0
LOCAL totrows := getproperty(windowname,gridname,"itemcount")
LOCAL leftspace := 0
LOCAL rightspace := 0
LOCAL firstrow := 0
LOCAL size1 := 0
LOCAL data1 := ""
LOCAL paperwidth := printgrid.width.value
LOCAL paperheight := printgrid.height.value
LOCAL totcols := 0
local papersize := 0
local sizesarr := {}
local totcol := 0
local colcount := 0


IF printgrid.printers.value > 0
   printername := AllTrim(printgrid.printers.item(printgrid.printers.value))
ELSE
   msgstop("You have to select a printer!","Print Wizard")
   RETURN nil
ENDIF
//private papernames := {"Letter","Legal","Executive","A3","A4","Custom"}

do case
   case printgrid.pagesizes.value == 1 //letter
      papersize := PRINTER_PAPER_LETTER
   case printgrid.pagesizes.value == 2 //legal
      papersize := PRINTER_PAPER_LEGAL
   case printgrid.pagesizes.value == 3 //executive
      papersize := PRINTER_PAPER_EXECUTIVE
   case printgrid.pagesizes.value == 4 //A3
      papersize := PRINTER_PAPER_A3
   case printgrid.pagesizes.value == 5 //A4
      papersize := PRINTER_PAPER_A4
   case printgrid.pagesizes.value == 6 //Custom
      papersize := PRINTER_PAPER_USER
endcase

if printgrid.pagesizes.value == 6 // custom
    SELECT PRINTER printername TO psuccess ORIENTATION IIf(printgrid.paperorientation.value == 1,PRINTER_ORIENT_LANDSCAPE,PRINTER_ORIENT_PORTRAIT);
        PAPERSIZE papersize;
        PAPERLENGTH printgrid.height.value;
        PAPERWIDTH printgrid.width.value;
        COPIES 1;
        PREVIEW
else
    SELECT PRINTER printername TO psuccess ORIENTATION IIf(printgrid.paperorientation.value == 1,PRINTER_ORIENT_LANDSCAPE,PRINTER_ORIENT_PORTRAIT);
        PAPERSIZE papersize;
        COPIES 1;
        PREVIEW
endif
IF .not. psuccess
   msgstop("Printer could not be selected! Check Availability of Printer.","Print Wizard")
   RETURN nil
ENDIF

size1 := val(alltrim(printgrid.selectfontsize.item(printgrid.selectfontsize.value)))


start printdoc
row := printgrid.top.value
maxrow1 := printgrid.height.value - printgrid.bottom.value
if printgrid.vertical.value
   col := (printgrid.width.value - printgrid.currentcol.value)/2
else
   col := printgrid.left.value
endif
lh := Int((size1/72 * 25.4)) + 1 // line height
start printpage
pageno := 1
IF printgrid.pageno.value == 2
   @ Row,(col+maxcol1 - printlen("Page No. :"+alltrim(str(pageno,10,0)),size1,fontname) - 5) print "Page No. : "+alltrim(str(pageno,10,0)) font fontname size size1
   row := row + lh
ENDIF
IF Len(AllTrim(printgrid.header1.value)) > 0
   @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.header1.value) font fontname size size1+2 center
   row := row + lh + lh
ENDIF
IF Len(AllTrim(printgrid.header2.value)) > 0
   @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.header2.value) font fontname size size1+2 center
   row := row + lh + lh
ENDIF
IF Len(AllTrim(printgrid.header3.value)) > 0
   @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.header3.value) font fontname size size1+2 center
   row := row + lh + lh
ENDIF

firstrow := Row
@ Row ,Col  print line TO Row ,col+maxcol1-1 penwidth 0.25
ASize(printdata,0)
ASize(justifyarr,0)
asize(sizesarr,0)
FOR i := 1 TO Len(columnarr)
   IF columnarr[i,1] == 1
      size := columnarr[i,3]
      data1 := columnarr[i,2]
      IF printLen(AllTrim(data1),size1,fontname) <= size
         AAdd(printdata,alltrim(data1))
      ELSE // header size bigger than column! to be truncated.
         j := len(data1)
         do while printlen(substr(data1,1,j),size1,fontname) > size
            j := j - 1
         enddo
         AAdd(printdata,substr(data1,1,j))
      ENDIF
      AAdd(justifyarr,columnarr[i,4])
      aadd(sizesarr,columnarr[i,3])
   ENDIF
NEXT i
printline(row,col,printdata,justifyarr,sizesarr,fontname,size1)
row := row + lh
@ Row,Col print line TO Row,col+maxcol1-1 penwidth 0.25
FOR i := 1 TO totrows
   curline := getproperty(windowname,gridname,"item",i)
   ASize(printdata,0)
   FOR j := 1 TO Len(columnarr)
      IF columnarr[j,1] == 1
         size := columnarr[j,3]
         data1 := curline[j]
         IF printLen(AllTrim(data1),size1,fontname) <= size
            aadd(printdata,alltrim(data1))
         ELSE  // truncate or wordwrap! as of now only truncate
            IF printgrid.wordwrap.value == 1
               l := len(data1)
               do while printlen(substr(data1,1,l),size1,fontname) > size
                  l := l - 1
               enddo
               AAdd(printdata,substr(data1,1,l))
            ELSE
               l := len(data1)
               do while printlen(substr(data1,1,l),size1,fontname) > size
                  l := l - 1
               enddo
               AAdd(printdata,substr(data1,1,l))
            ENDIF
         ENDIF
      ENDIF
   NEXT j
   printline(row,col,printdata,justifyarr,sizesarr,fontname,size1,lh)
   Row := Row + lh
/*
   IF maxlines > 0
      FOR k := 2 TO maxlines
         ASize(printdata,0)
         FOR l := 1 TO Len(columnarr)
            IF columnarr[l,1] == 1
               size := columnarr[l,3]
               data1 := curline[l]
               IF Len(AllTrim(data1)) > (k-1) * size
                  AAdd(printdata,substr(data1,((k-1) * size+1),size)+"")
               ELSE
                  AAdd(printdata,Space(size)+"")
               ENDIF
            ENDIF
         NEXT l
         printline(row,col,printdata,justifyarr,sizesarr,fontname,size1,lh,cw)
         Row := Row + 1
      NEXT k
   ENDIF
   */
   IF Row+lh >= maxrow1
      @ Row,Col print line TO Row,col+maxcol1-1  penwidth 0.25
      lastrow := Row
      totcol := 0
      @ firstrow,Col print line TO lastrow,Col  penwidth 0.25
      IF printgrid.collines.value
         colcount := 0
         for k := 1 to len(columnarr)
            IF columnarr[k,1] == 1
                  totcol := totcol + columnarr[k,3]
                  colcount := colcount + 1
                  @ firstrow,col+totcol+(colcount * 2)-1 print line TO lastrow,col+totcol+(colcount * 2)-1 penwidth 0.25
            ENDIF
         next k
      ENDIF
      @ firstrow,col+maxcol1-1 print line TO lastrow,col+maxcol1-1 penwidth 0.25
      IF Len(AllTrim(printgrid.footer1.value)) > 0
         @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.footer1.value) font fontname size size1+2 center
         row := row + lh + lh
      ENDIF
      IF printgrid.pageno.value == 3
         Row := Row + lh
         @ Row,(col+maxcol1 - printlen("Page No. :"+alltrim(str(pageno,10,0)),size1,fontname) - 5) print "Page No. : "+alltrim(str(pageno,10,0)) font fontname size size1
      ENDIF
      END printpage
      pageno := pageno + 1
      row := printgrid.top.value
      start printpage
      IF printgrid.pageno.value == 2
         @ Row,(col+maxcol1 - printlen("Page No. :"+alltrim(str(pageno,10,0)),size1,fontname) - 5) print "Page No. : "+alltrim(str(pageno,10,0)) font fontname size size1
         row := row + lh
      ENDIF
      IF Len(AllTrim(printgrid.header1.value)) > 0
         @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.header1.value) font fontname size size1+2 center
         row := row + lh + lh
      ENDIF
      IF Len(AllTrim(printgrid.header2.value)) > 0
         @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.header2.value) font fontname size size1+2 center
         row := row + lh + lh
      ENDIF
      IF Len(AllTrim(printgrid.header3.value)) > 0
         @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.header3.value) font fontname size size1+2 center
         row := row + lh + lh
      ENDIF

      firstrow := Row
      @ Row ,Col  print line TO Row ,col+maxcol1-1 penwidth 0.25
      ASize(printdata,0)
      ASize(justifyarr,0)
      asize(sizesarr,0)
      FOR k := 1 TO Len(columnarr)
         IF columnarr[k,1] == 1
            size := columnarr[k,3]
            data1 := columnarr[k,2]
            IF printLen(AllTrim(data1),size1,fontname) <= size
               AAdd(printdata,alltrim(data1))
            ELSE // header size bigger than column! to be truncated.
               j := len(data1)
               do while printlen(substr(data1,1,j),size1,fontname) > size
                  j := j - 1
               enddo
               AAdd(printdata,substr(data1,1,j))
            ENDIF
            AAdd(justifyarr,columnarr[k,4])
            aadd(sizesarr,columnarr[k,3])
         ENDIF
      NEXT k
      printline(row,col,printdata,justifyarr,sizesarr,fontname,size1)
      row := row + lh
      @ Row,Col print line TO Row,col+maxcol1-1 penwidth 0.25
   ELSE
      IF printgrid.rowlines.value
         @ Row,Col print line TO Row,col+maxcol1-1 penwidth 0.25
      ENDIF
   ENDIF
NEXT i
@ Row,Col print line TO Row,col+maxcol1-1 penwidth 0.25
lastrow := Row
totcol := 0
colcount := 0
@ firstrow,Col print line TO lastrow,Col penwidth 0.25
IF printgrid.collines.value
   for k := 1 to len(columnarr)
      IF columnarr[k,1] == 1
         totcol := totcol + columnarr[k,3]
         colcount := colcount + 1
         @ firstrow,col+totcol+(colcount * 2)-1 print line TO lastrow,col+totcol+(colcount * 2)-1 penwidth 0.25
      ENDIF
   next k
ENDIF
@ firstrow,col+maxcol1-1 print line TO lastrow,col+maxcol1-1 penwidth 0.25

IF Len(AllTrim(printgrid.footer1.value)) > 0
   @ Row+(lh/2),col+Int(maxcol1/2) print AllTrim(printgrid.footer1.value) font fontname size size1+2 center
   row := row + lh + lh
ENDIF
IF printgrid.pageno.value == 3
   Row := Row + lh
   @ Row,(col+maxcol1 - printlen("Page No. :"+alltrim(str(pageno,10,0)),size1,fontname) - 5) print "Page No. : "+alltrim(str(pageno,10,0)) font fontname size size1
ENDIF
end printpage
end printdoc
IF iswindowactive(printgrid)
   printgrid.release
ENDIF
return nil


FUNCTION printgridtoggle
LOCAL lineno := printgrid.columns.value
LOCAL linedetail := {}
IF lineno > 0
   IF columnarr[lineno,1] == 1
      columnarr[lineno,1] := 0
   ELSE
      columnarr[lineno,1] := 1
   ENDIF
   refreshcolumnprintgrid()
   printcoltally()
   printgridpreview()
   printgrid.columns.value := lineno
ENDIF
RETURN nil

FUNCTION refreshcolumnprintgrid
printgrid.columns.deleteallitems()
FOR i := 1 TO Len(columnarr)
   printgrid.columns.additem({columnarr[i,1],columnarr[i,2],AllTrim(Str(columnarr[i,3]))})
NEXT i
RETURN nil

FUNCTION editcoldetails
LOCAL lineno := printgrid.columns.value
LOCAL columnsize := 0
IF lineno > 0
   columnsize := columnarr[lineno,3]
   if typearr[lineno] == "C"
      DEFINE window editgrid At 0,0 width 120 height 100 title AllTrim(columnarr[lineno,2]) modal nosize nosysmenu
         DEFINE label sizelabel
            Row 10
            Col 10
            value "Size :"
            width 40
         END label
         DEFINE textbox size
            Row 10
            Col 50
            width 60
            value columnsize
            readonly iif(typearr[lineno] == "C",.f.,.t.)
            tabstop iif(typearr[lineno] == "C",.t.,.f.)
            numeric .t.
            rightalign .t.
            inputmask "999.99"
         END textbox
         DEFINE button done
            Row 40
            Col 35
            width 50
            caption "Done"
            action setprintgridcoldetails()
         END button
      END window
      editgrid.center
      editgrid.activate
   else
      msginfo("Size of Columns other than text type can not be modified!")
   endif
ENDIF
RETURN nil

FUNCTION setprintgridcoldetails
LOCAL lineno := printgrid.columns.value
LOCAL curline := {}
IF lineno > 0
   columnarr[lineno,3] := editgrid.size.value
ENDIF
refreshcolumnprintgrid()
printgrid.columns.value := lineno
printcoltally()
printgridpreview()
editgrid.release
RETURN nil

function printline(row,col,aitems,ajustify,sizesarr,fontname,size1)
local tempcol := 0
local i := 0
if len(aitems) <> len(ajustify)
   msginfo("Justification constants not given properly.")
ENDIF
tempcol := col
for i := 1 to len(aitems)
   njustify := ajustify[i]
   do case
      case njustify == 0 //left
         @ Row,tempcol print aitems[i] font fontname size size1
      case njustify == 1 //right
         @ Row,tempcol+sizesarr[i] print aitems[i] font fontname size size1 right
      case njustify == 2 // center
         @ Row,tempcol+(sizesarr[i]/2) print aitems[i] font fontname size size1 center
   end case
   tempcol := tempcol + sizesarr[i] + 2
next i
return nil

function printLen( cString,fontsize,fontname)
return round(gettextwidth(Nil,cString,fontname)*0.072/72*25.4*fontsize,2)

function papersizechanged
if printgrid.pagesizes.value > 0
   if printgrid.paperorientation.value == 2 //portrait
      printgrid.width.value := papersizes[printgrid.pagesizes.value,1]
      printgrid.height.value := papersizes[printgrid.pagesizes.value,2]
   else // landscape
      printgrid.width.value := papersizes[printgrid.pagesizes.value,2]
      printgrid.height.value := papersizes[printgrid.pagesizes.value,1]
   endif
   printgrid.maximumcol.value := printgrid.width.value - printgrid.left.value - printgrid.right.value
endif
if printgrid.pagesizes.value == printgrid.pagesizes.itemcount // custom
   printgrid.width.readonly := .f.
   printgrid.height.readonly := .f.
else
   printgrid.width.readonly := .t.
   printgrid.height.readonly := .t.
endif
refreshcolumnprintgrid()
printcoltally()
printgridpreview()
return nil


function printgridpreview
local startx := 10
local starty := 300
local endx := 360
local endy := 690
local maxwidth := endy - starty - (10 * 2) // 10 for each side
local maxheight := endx - startx - (10 * 2)
local width := printgrid.width.value
local height := printgrid.height.value
local resize := 1
local curx := 0
local cury := 0
LOCAL curline := {}
LOCAL lh := 0 // line height
LOCAL pageno := 0
LOCAL printdata := {}
LOCAL justifyarr := {}
LOCAL totrows := getproperty(windowname,gridname,"itemcount")
LOCAL firstrow := 0
LOCAL size1 := 0
LOCAL data1 := ""
local sizesarr := {}
local totcol := 0
local maxrow1 := 0
LOCAL maxcol1 := printgrid.currentcol.value
local pl := 0
local colcount := 0

if maxwidth >= width .and. maxheight >= height
   resize := 1 // resize not required
else
   resize := min(maxwidth/width,maxheight/height)
endif

curx := startx + (maxheight - (height * resize))/2 + 10
cury := starty + (maxwidth - (width * resize))/2 + 10
ERASE WINDOW printgrid
DRAW RECTANGLE IN WINDOW printgrid AT curx,cury	TO curx + (height * resize),cury + (width * resize) FILLCOLOR {255,255,255}

size1 := val(alltrim(printgrid.selectfontsize.item(printgrid.selectfontsize.value)))

maxrow1 := curx + ((printgrid.height.value - printgrid.bottom.value) * resize)
curx := curx+ (printgrid.top.value * resize)
maxcol1 := (maxcol1) * resize
if printgrid.vertical.value
   cury := cury + ((printgrid.width.value - printgrid.currentcol.value)/2 * resize)
else
   cury := cury + (printgrid.left.value * resize)
endif

lh := (Int((size1/72 * 25.4)) + 1) * resize // line height
pageno := 1
IF printgrid.pageno.value == 2
   pl := printlen("Page No. :"+alltrim(str(pageno,10,0)),size1,fontname)*resize
   draw line in window printgrid at curx,cury+maxcol1 - pl to curx,cury+maxcol1
   curx := curx + lh
ENDIF
IF Len(AllTrim(printgrid.header1.value)) > 0
   pl := printlen(AllTrim(printgrid.header1.value),size1,fontname) * resize
   draw line in window printgrid at curx+(lh/2),cury + ((maxcol1 - pl)/2) to curx+(lh/2),cury + ((maxcol1 - pl)/2) + pl
   curx := curx + lh + lh
ENDIF
IF Len(AllTrim(printgrid.header2.value)) > 0
   pl := printlen(AllTrim(printgrid.header2.value),size1,fontname) * resize
   draw line in window printgrid at curx+(lh/2),cury + ((maxcol1 - pl)/2) to curx+(lh/2),cury + ((maxcol1 - pl)/2) + pl
   curx := curx + lh + lh
ENDIF
IF Len(AllTrim(printgrid.header3.value)) > 0
   pl := printlen(AllTrim(printgrid.header3.value),size1,fontname) * resize
   draw line in window printgrid at curx+(lh/2),cury + ((maxcol1 - pl)/2) to curx+(lh/2),cury + ((maxcol1 - pl)/2) + pl
   curx := curx + lh + lh
ENDIF

firstrow := curx
draw line in window printgrid at curx,cury to curx,cury+maxcol1-(1*resize)
ASize(printdata,0)
ASize(justifyarr,0)
asize(sizesarr,0)
FOR i := 1 TO Len(columnarr)
   IF columnarr[i,1] == 1
      size := columnarr[i,3]
      data1 := columnarr[i,2]
      IF printLen(AllTrim(data1),size1,fontname) <= size
         AAdd(printdata,alltrim(data1))
      ELSE // header size bigger than column! to be truncated.
         j := len(data1)
         do while printlen(substr(data1,1,j),size1,fontname) > size
            j := j - 1
         enddo
         AAdd(printdata,substr(data1,1,j))
      ENDIF
      AAdd(justifyarr,columnarr[i,4])
      aadd(sizesarr,columnarr[i,3])
   ENDIF
NEXT i
printpreviewline(curx+(lh/2),cury,printdata,justifyarr,sizesarr,fontname,size1,resize)
curx := curx + lh
draw line in window printgrid at curx,cury to curx,cury+maxcol1-(1*resize)
FOR i := 1 TO totrows
   curline := getproperty(windowname,gridname,"item",i)
   ASize(printdata,0)
   FOR j := 1 TO Len(columnarr)
      IF columnarr[j,1] == 1
         size := columnarr[j,3]
         data1 := curline[j]
         IF printLen(AllTrim(data1),size1,fontname) <= size
            aadd(printdata,alltrim(data1))
         ELSE  // truncate or wordwrap! as of now only truncate
            IF printgrid.wordwrap.value == 1
               l := len(data1)
               do while printlen(substr(data1,1,l),size1,fontname) > size
                  l := l - 1
               enddo
               AAdd(printdata,substr(data1,1,l))
            ELSE
               l := len(data1)
               do while printlen(substr(data1,1,l),size1,fontname) > size
                  l := l - 1
               enddo
               AAdd(printdata,substr(data1,1,l))
            ENDIF
         ENDIF
      ENDIF
   NEXT j
   printpreviewline(curx+(lh/2),cury,printdata,justifyarr,sizesarr,fontname,size1,resize)
   curx := curx + lh
   IF curx+lh >= maxrow1
      draw line in window printgrid at curx,cury to curx,cury+maxcol1-(1*resize)
      lastrow := curx
      totcol := 0
      draw line in window printgrid at firstrow,cury to lastrow,cury
      IF printgrid.collines.value
         colcount := 0
         for k := 1 to len(columnarr)
            IF columnarr[k,1] == 1
               colcount := colcount + 1
               totcol := totcol + columnarr[k,3]
               draw line in window printgrid at firstrow,cury+(totcol+(colcount * 2)-1) * resize to lastrow,cury+(totcol+(colcount * 2)-1) * resize
            ENDIF
         next k
      ENDIF
      draw line in window printgrid at firstrow,cury+maxcol1-(1*resize) to lastrow,cury+maxcol1-(1*resize)
      IF Len(AllTrim(printgrid.footer1.value)) > 0
         pl := printlen(AllTrim(printgrid.footer1.value),size1,fontname) * resize
         draw line in window printgrid at curx+(lh/2),cury + ((maxcol1 - pl)/2) to curx+(lh/2),cury + ((maxcol1 - pl)/2) + pl
         curx := curx + lh + lh
      ENDIF
      IF printgrid.pageno.value == 3
         pl := printlen("Page No. :"+alltrim(str(pageno,10,0)),size1,fontname)*resize
         draw line in window printgrid at curx,cury+maxcol1 - pl to curx,cury+maxcol1
         curx := curx + lh
      ENDIF
      i := totrows
   ELSE
      IF printgrid.rowlines.value
         draw line in window printgrid at curx,cury to curx,cury+maxcol1-(1*resize)
      ENDIF
   ENDIF
NEXT i
draw line in window printgrid at curx,cury to curx,cury+maxcol1-(1*resize)
lastrow := curx
totcol := 0
colcount := 0
draw line in window printgrid at firstrow,cury to lastrow,cury
IF printgrid.collines.value
   for k := 1 to len(columnarr)
      IF columnarr[k,1] == 1
         totcol := totcol + columnarr[k,3]
         colcount := colcount + 1
         draw line in window printgrid at firstrow,cury+(totcol+(colcount * 2)-1) * resize to lastrow,cury+(totcol+(colcount * 2)-1) * resize
      ENDIF
   next k
ENDIF
draw line in window printgrid at firstrow,cury+maxcol1-(1*resize) to lastrow,cury+maxcol1-(1*resize)
IF Len(AllTrim(printgrid.footer1.value)) > 0
   pl := printlen(AllTrim(printgrid.footer1.value),size1,fontname) * resize
   draw line in window printgrid at curx+(lh/2),cury + ((maxcol1 - pl)/2) to curx+(lh/2),cury + ((maxcol1 - pl)/2) + pl
   curx := curx + lh + lh
ENDIF
IF printgrid.pageno.value == 3
   pl := printlen("Page No. :"+alltrim(str(pageno,10,0)),size1,fontname)*resize
   draw line in window printgrid at curx,cury+maxcol1 - pl to curx,cury+maxcol1
   curx := curx + lh
ENDIF
return nil


function printpreviewline(row,col,aitems,ajustify,sizesarr,fontname,size1,resize)
local tempcol := 0
local i := 0
if len(aitems) <> len(ajustify)
   msginfo("Justification constants not given properly.")
ENDIF
tempcol := col
for i := 1 to len(aitems)
   njustify := ajustify[i]
   pl := printlen(AllTrim(aitems[i]),size1,fontname) * resize
   do case
      case njustify == 0 //left
         draw line in window printgrid at row,tempcol to row,tempcol+pl
      case njustify == 1 //right
         draw line in window printgrid at row,tempcol+((sizesarr[i] + 2) * resize)-pl to row,tempcol+((sizesarr[i] + 2) * resize)
      case njustify == 2 //center not implemented
         draw line in window printgrid at row,tempcol to row,tempcol+pl
   end case
   tempcol := tempcol + ((sizesarr[i] + 2) * resize)
next i
return nil